; GUI #
include win64a.inc
; --------------- 
WINDOWWIDTH  = 800
WINDOWHEIGHT = 600

xrot	equ rot
yrot	equ rot+4
zrot	equ rot+8
xspeed	equ speed
yspeed	equ speed+4
zspeed	equ speed+4
GLvector4f struct
	dd 4 dup(?)
GLvector4f ends
GLmatrix16f struct
	dd 16 dup(?)
GLmatrix16f ends
; Point3f      3D . 
;      
sPoint struct;    
	x dd ?
	y dd ?
	z dd ?
sPoint ends
; Plane  4 ,     
; .       ( )
sPlaneEq struct;  ,  : ax + by + cz + d = 0
	a  dd ?
	b  dd ?
	c_ dd ?
	d  dd ?
sPlaneEq ends
;      ,   
;    .     
;.
;  (vertexIndices) ,    
;   3D,     ,     
;      ,    .
;  (planeEquation)  ,    
;   3D.
;  (neighbourIndices) -     .  
;  ,         
; .
;  (visible) ,  ,    
;""  ,   .
sPlane struct
;    ,    
	p dd 3 dup(?)
	normals sPoint 3 dup (<>);  
;  ,      
	neigh dd 3 dup(?)
	PlaneEq sPlaneEq <>;   
	visible db ?;   ?
sPlane ends
; glObject      .     
;  ,   
glObject struct
	nPlanes dd ?
	nPoints dd ?;
	points sPoint 100 dup (<>)
	planes sPlane 200 dup (<>)
glObject ends
.code
WinMain	proc
local	msg:MSG

	xor	ebx,ebx
        mov	edi,offset szClassName
        mov	esi,IMAGE_BASE
        mov	ecx,offset FileName
	invoke	LoadCursorFromFile
        push	rax	;hIconSm
	push	rdi	;lpszClassName
	push	rbx	;lpszMenuName
	push	COLOR_WINDOWTEXT+1;hbrBackground
	push	rax	;hCursor
	push	rax        ;hIcon
	push	rsi	;hInstance
	push	rbx        ;cbClsExtra & cbWndExtra
	pushaddr WndProc;lpfnWndProc
	mov	rax,(CS_HREDRAW or CS_VREDRAW or CS_OWNDC)shl 32 \
	or (sizeof WNDCLASSEX)
	push	rax	;cbSize & style
    	invoke	RegisterClassEx,esp	;addr WNDCLASSEX
	
	push	rbx
	push	rsi	;rsi = 400000h
	shl	esi,9	;rsi = CW_USEDEFAULT
	push	rbx
	push	rbx
	push	WINDOWHEIGHT
	push	WINDOWWIDTH
	push	rsi
	push	rsi
	sub	esp,20h
    	invoke	CreateWindowEx,0,edi,edi,WS_OVERLAPPEDWINDOW or \
	WS_CLIPCHILDREN or WS_CLIPSIBLINGS or WS_VISIBLE
; 
    	lea	edi,msg
@@:	invoke	GetMessage,edi,0,0,0	
	invoke	DispatchMessage,edi
	jmp	@b
WinMain endp
WndProc	proc	hWin:QWORD,uMsg:QWORD,wParam:QWORD,lParam:QWORD
local	buf[100h]:dword
local	ps:PAINTSTRUCT
local	w:dword
local	h:dword
local	Minv:GLmatrix16f
local	wlp:GLvector4f
local	lp:GLvector4f
local	temp:dword

        mov	hWin,rcx
	xor	ebx,ebx

        cmp	edx,WM_CREATE
	je      wmCREATE
        cmp	edx,WM_SIZE
	je      wmSIZE
        cmp	edx,WM_PAINT
	je      wmPAINT
	cmp	edx,WM_TIMER
	je	wmTIMER
        cmp	edx,WM_DESTROY
	je      wmDESTROY
        cmp	edx,WM_KEYDOWN
	je      wmKEYDOWN          
default:leave
	jmp	NtdllDefWindowProc_
wmDESTROY:invoke wglMakeCurrent,0,0
	invoke	wglDeleteContext,hRC
	invoke	ReleaseDC,hWin,hDC
        invoke	KillTimer,hWin,10

	invoke	RtlExitUserProcess,NULL
;------------------------------
wmTIMER:movaps	xmm0,rot
	addps	xmm0,speed
	movaps	rot,xmm0;xrot+=xspeed; 
        invoke	InvalidateRect,,0,0
	jmp	wmBYE
wmKEYDOWN:mov	al,r8b;wParam
	cmp	al,VK_ESCAPE;user press 'Esc'? 1Bh
	je	wmDESTROY
	cmp	al,VK_LEFT
	jne	@f
	movss	xmm0,yspeed
	subss	xmm0,const0_1
	movss	yspeed,xmm0; 'Arrow Left' Decrease yspeed
	jmp	@0
@@:	cmp	al,VK_RIGHT
	jne	@f
	movss	xmm0,yspeed
	addss	xmm0,const0_1
	movss	yspeed,xmm0; 'Arrow Right' Increase yspeed
	jmp	@0
@@:	cmp	al,VK_UP
	jne	@f
	movss	xmm0,xspeed
	subss	xmm0,const0_1
	movss	xspeed,xmm0; 'Arrow Up' Decrease xspeed
	jmp	@0
@@:	cmp	al,VK_DOWN
	jne	@f
	movss	xmm0,xspeed
	addss	xmm0,const0_1
	movss	xspeed,xmm0; 'Arrow Down' Increase xspeed
	jmp	@0
; Adjust Light's Position
@@:	cmp	al,VK_L 
	jne	@f
	movss	xmm0,LightPos[0*4]
	addss	xmm0,const0_05
	movss	LightPos[0*4],xmm0; 'L' Moves Light Right
	jmp	@0
@@:	cmp	al,VK_J 
	jne	@f
	movss	xmm0,LightPos[0*4]; -= 0.05; 'J' Moves Light Left
	subss	xmm0,const0_05
	movss	LightPos[0*4],xmm0
	jmp	@0
@@:	cmp	al,VK_I 
	jne	@f
	movss	xmm0,LightPos[1*4]; += 0.05; 'I' Moves Light Up
	addss	xmm0,const0_05
	movss	LightPos[1*4],xmm0
	jmp	@0
@@:	cmp	al,VK_K 
	jne	@f
	movss	xmm0,LightPos[1*4]; -= 0.05; 'K' Moves Light Down
	subss	xmm0,const0_05
	movss	LightPos[1*4],xmm0
	jmp	@0
@@:	cmp	al,VK_O 
	jne	@f
	movss	xmm0,LightPos[2*4]; += 0.05; 'O' Moves Light Toward Viewer
	addss	xmm0,const0_05
	movss	LightPos[2*4],xmm0
	jmp	@0
@@:	cmp	al,VK_U 
	jne	@f
	movss	xmm0,LightPos[2*4]; -= 0.05; 'U' Moves Light Away From Viewer
	subss	xmm0,const0_05
	movss	LightPos[2*4],xmm0
	jmp	@0
; Adjust Object's Position
@@:	cmp	al,VK_NUMPAD6 
	jne	@f
	movss	xmm0,ObjPos[0*4]; += 0.05; 'Numpad6' Move Object Right
	addss	xmm0,const0_05
	movss	ObjPos[0*4],xmm0
	jmp	@0
@@:	cmp	al,VK_NUMPAD4 
	jne	@f
	movss	xmm0,ObjPos[0*4]; -= 0.05; 'Numpad4' Move Object Left
	subss	xmm0,const0_05
	movss	ObjPos[0*4],xmm0
	jmp	@0
@@:	cmp	al,VK_NUMPAD8 
	jne	@f
	movss	xmm0,ObjPos[1*4]; += 0.05; 'Numpad8' Move Object Up
	addss	xmm0,const0_05
	movss	ObjPos[1*4],xmm0
	jmp	@0
@@:	cmp	al,VK_NUMPAD5 
	jne	@f
	movss	xmm0,ObjPos[1*4]; -= 0.05; 'Numpad5' Move Object Down
	subss	xmm0,const0_05
	movss	ObjPos[1*4],xmm0
	jmp	@0
@@:	cmp	al,VK_NUMPAD9 
	jne	@f
	movss	xmm0,ObjPos[2*4]; += 0.05; 'Numpad9' Move Object Toward Viewer
	addss	xmm0,const0_05
	movss	ObjPos[2*4],xmm0
	jmp	@0
@@:	cmp	al,VK_NUMPAD7 
	jne	@f
	movss	xmm0,ObjPos[2*4]; -= 0.05; 'Numpad7' Move Object Away From Viewer
	subss	xmm0,const0_05
	movss	ObjPos[2*4],xmm0
	jmp	@0
; Adjust Ball's Position
@@:	cmp	al,VK_D
	jne	@f 
	movss	xmm0,SpherePos[0*4]; += 0.05; 'D' Move Ball Right
	addss	xmm0,const0_05
	movss	SpherePos[0*4],xmm0
	jmp	@0
@@:	cmp	al,VK_A
	jne	@f 
	movss	xmm0,SpherePos[0*4]; -= 0.05; 'A' Move Ball Left
	subss	xmm0,const0_05
	movss	SpherePos[0*4],xmm0
	jmp	@0
@@:	cmp	al,VK_W
	jne	@f 
	movss	xmm0,SpherePos[1*4]; += 0.05; 'W' Move Ball Up
	addss	xmm0,const0_05
	movss	SpherePos[1*4],xmm0
	jmp	@0
@@:	cmp	al,VK_S
	jne	@f 
	movss	xmm0,SpherePos[1*4]; -= 0.05; 'S' Move Ball Down
	subss	xmm0,const0_05
	movss	SpherePos[1*4],xmm0
	jmp	@0
@@:	cmp	al,VK_E 
	jne	@f
	movss	xmm0,SpherePos[2*4]; += 0.05; 'E' Move Ball Toward Viewer
	addss	xmm0,const0_05
	movss	SpherePos[2*4],xmm0
	jmp	@0
@@:	cmp	al,VK_Q 
	jne	wmBYE
	movss	xmm0,SpherePos[2*4]; -= 0.05; 'Q' Move Ball Away From Viewer
	subss	xmm0,const0_05
	movss	SpherePos[2*4],xmm0
@0:	invoke	InvalidateRect,,0,0
        jmp	wmBYE
;-----------------------------------------	
wmCREATE:invoke	GetDC ;  
	mov	hDC,rax
;    OpenGL ( OpenGL   
;)  
        mov	edx,offset PixFrm
	invoke	ChoosePixelFormat,eax
;  
	mov	r8d,offset PixFrm
	invoke	SetPixelFormat,hDC,eax
;     OpenGL
	invoke	wglCreateContext,hDC
	mov	hRC,rax
;   
	invoke	wglMakeCurrent,hDC,eax
	invoke	SetTimer,hWin,10,25,0;  #10  25mSec
;-------------------------------------------------------
        mov	edx,offset obj
	mov	ecx,offset aObject ; "Object2.txt"
	invoke	ReadObject
	mov	ecx,offset obj
	invoke	SetConnectivity
	xor	edi,edi
        imul	eax,obj.nPlanes,80
	mov	temp,eax
; ---------------------------------------------------------------------------
@@:	lea	edx,obj.planes[rdi]
	mov	ecx,offset obj
	invoke	CalcPlane
	add	edi,80
	cmp	edi,temp
	jb	@b
; ---------------------------------------------------------------------------
	invoke	glShadeModel, GL_SMOOTH
	movss	xmm3, const0_5
	xorps	xmm2, xmm2
	xorps	xmm1, xmm1
	xorps	xmm0, xmm0
	invoke	glClearColor
	movsd	xmm0, constd1
	invoke	glClearDepth
	invoke	glClearStencil,0
	invoke	glEnable, GL_DEPTH_TEST
	invoke	glDepthFunc, GL_LEQUAL
	invoke	glHint, GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST
	mov	r8d,offset LightPos
	invoke	glLightfv, GL_LIGHT1,GL_POSITION
	mov	r8d,offset LightAmb
	invoke	glLightfv, GL_LIGHT1, GL_AMBIENT
	mov	r8d,offset LightDif
	invoke	glLightfv, GL_LIGHT1, GL_DIFFUSE
	mov	r8d,offset LightSpc
	invoke	glLightfv, GL_LIGHT1, GL_SPECULAR
	invoke	glEnable, GL_LIGHT1
	invoke	glEnable, GL_LIGHTING
	mov	r8d,offset MatAmb
	invoke	glMaterialfv, GL_FRONT, GL_AMBIENT
	mov	r8d,offset MatDif
	invoke	glMaterialfv, GL_FRONT, GL_DIFFUSE
	mov	r8d,offset MatSpc
	invoke	glMaterialfv, GL_FRONT, GL_SPECULAR
	mov	r8d,offset MatShn
	invoke	glMaterialfv, GL_FRONT, GL_SHININESS
	invoke	glCullFace, GL_BACK
	invoke	glEnable, GL_CULL_FACE
	movss	xmm3, const1
	movss	xmm2, const0_5
	movss	xmm1,xmm3
	movss	xmm0, const0_1
	invoke	glClearColor
	invoke	gluNewQuadric
	mov	q, rax
	invoke	gluQuadricNormals,eax, GL_SMOOTH
	invoke	gluQuadricTexture,q, GL_FALSE
	mov	r9d,(WINDOWHEIGHT shl 16)or WINDOWWIDTH 
wmSIZE:; --------------- Resize the scene
	movzx	r8,r9w
	mov	w,r8d
	shr	r9d,16
	mov	h,r9d
	invoke	glViewport,0,0;     
        invoke	glMatrixMode,GL_PROJECTION;     
	invoke	glLoadIdentity;		   
;    , ..    (  glcall ..     8 )
	movq	xmm3,constd100
	movq	xmm2,constd0_001
	cvtsi2sd xmm1,w
	cvtsi2sd xmm0,h
	divsd	xmm1,xmm0
	movq	xmm0,constd45
	invoke	gluPerspective
;    
	invoke	glMatrixMode,GL_MODELVIEW;     ()
	invoke	glLoadIdentity		;   
        jmp	wmBYE
wmPAINT:; No pending messages: draw the scene
	lea	edx,ps
	invoke  BeginPaint
; --------------- Display the scene
        invoke	glClear,GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT or GL_STENCIL_BUFFER_BIT
	invoke	glLoadIdentity
	movss	xmm2, const_20
	xorps	xmm1, xmm1
	xorps	xmm0, xmm0
	invoke	glTranslatef
	mov	r8d,offset LightPos
	invoke	glLightfv, GL_LIGHT1,GL_POSITION
	lea	rcx, SpherePos
	movss	xmm2, dword ptr	[rcx+2*4]
	movss	xmm1, dword ptr	[rcx+1*4]
	movss	xmm0, dword ptr	[rcx+0*4]
	invoke	glTranslatef
	movsd	xmm1, constd1_5
	invoke	gluSphere,q,,32,16
	invoke	glLoadIdentity
	xorps	xmm0,xmm0
	subss	xmm0, yrot
	xorps	xmm3, xmm3
	movss	xmm2, const1
	xorps	xmm1, xmm1
	invoke	glRotatef
	xorps	xmm0,xmm0
	subss	xmm0, xrot
	xorps	xmm3, xmm3
	xorps	xmm2, xmm2
	movss	xmm1, const1
	invoke	glRotatef
	lea	edx, Minv
	invoke	glGetFloatv, GL_MODELVIEW_MATRIX
	movss	xmm0, dword ptr	LightPos[0*4]
	movss	dword ptr lp[0*4], xmm0
	movss	xmm0, dword ptr	LightPos[1*4]
	movss	dword ptr lp[1*4], xmm0
	movss	xmm0, dword ptr	LightPos[2*4]
	movss	dword ptr lp[2*4], xmm0
	movss	xmm0, dword ptr	LightPos[3*4]
	movss	dword ptr lp[3*4], xmm0
	lea	edx, lp
	lea	ecx, Minv
	invoke	VMatMult
	xorps	xmm2,xmm2
	subss	xmm2,ObjPos[2*4]
	xorps	xmm1,xmm1
	subss	xmm1,ObjPos[1*4]
	xorps	xmm0,xmm0
	subss	xmm0,ObjPos[0*4]
	invoke	glTranslatef
	lea	edx, Minv
	invoke	glGetFloatv, GL_MODELVIEW_MATRIX
	xorps	xmm0, xmm0
	movss	dword ptr wlp[0*4], xmm0
	movss	dword ptr wlp[1*4], xmm0
	movss	dword ptr wlp[2*4], xmm0
	movr	dword ptr wlp[3*4],1.0
	lea	edx, wlp
	lea	ecx, Minv
	invoke	VMatMult
	movss	xmm0, dword ptr	lp[0*4]
	addss	xmm0, dword ptr	wlp[0*4]
	movss	dword ptr lp[0*4], xmm0
	movss	xmm0, dword ptr	lp[1*4]
	addss	xmm0, dword ptr	wlp[1*4]
	movss	dword ptr lp[1*4], xmm0
	movss	xmm0, dword ptr	lp[2*4]
	addss	xmm0, dword ptr	wlp[2*4]
	movss	dword ptr lp[2*4], xmm0
	movss	xmm3, const1
	xorps	xmm2, xmm2
	movss	xmm1, const0_4
	movss	xmm0, const0_7
	invoke	glColor4f
	invoke	glLoadIdentity
	movss	xmm2, const_20
	xorps	xmm1, xmm1
	xorps	xmm0, xmm0
	invoke	glTranslatef
	invoke	DrawGLRoom
	movss	xmm2,dword ptr ObjPos[2*4]
	movss	xmm1,dword ptr ObjPos[1*4]
	movss	xmm0,dword ptr ObjPos[0*4]
	invoke	glTranslatef
	xorps	xmm3,xmm3
	xorps	xmm2,xmm2
	movss	xmm1,const1
	movss	xmm0,xrot
	invoke	glRotatef
	xorps	xmm3,xmm3
	movss	xmm2,const1
	xorps	xmm1,xmm1
	movss	xmm0,yrot
	invoke	glRotatef
	mov	ecx,offset obj
	invoke	DrawGLObject
	lea	edx,lp
	mov	ecx,offset obj
	invoke	CastShadow
	movss	xmm3,const1
	xorps	xmm2,xmm2
	movss	xmm1,const0_4
	movss	xmm0,const0_7
	invoke	glColor4f
	invoke	glDisable, GL_LIGHTING
	invoke	glDepthMask,GL_FALSE
	movss	xmm2,dword ptr	lp[2*4]
	movss	xmm1,dword ptr	lp[1*4]
	movss	xmm0,dword ptr	lp[0*4]
	invoke	glTranslatef
	movsd	xmm1,constd0_2
	invoke	gluSphere,q,,16,8
	invoke	glEnable,GL_LIGHTING
	invoke	glDepthMask,GL_TRUE
	invoke	glFlush; Flush The OpenGL Pipeline
;   
	invoke	SwapBuffers,hDC
        lea	edx,ps
	invoke	EndPaint,hWin
wmBYE:	leave
	retn
WndProc	endp
;    ,      . 
;     1,  ,   . 
;   .
ReadObject proc  Filename:dword,object:qword
local	hFile:qword
local	temp:dword

	mov	esi,edx
	
	mov	edx,offset readmode	; "r"
	invoke	fopen
	mov	hFile, rax
	or	eax,eax
	jz	exit0
; ---------------------------------------------------------------------------
	lea	r8d,[rsi].glObject.nPoints;&(object->nPoints)
	mov	edx,offset format_d	; "%d"
	invoke	fscanf, hFile
	imul	eax,[rsi].glObject.nPoints,sizeof sPoint
	mov	temp,eax
	mov	edi,(sizeof sPoint)
; ---------------------------------------------------------------------------
@0:	lea	r8d,[rsi+rdi].glObject.points.x
	mov	edx,offset format_f	; "%f"
	invoke	fscanf,hFile
	lea	r8d,[rsi+rdi].glObject.points.y
	mov	edx,offset format_f	; "%f"
	invoke	fscanf,hFile
	lea	r8d,[rsi+rdi].glObject.points.z
	mov	edx,offset format_f	; "%f"
	invoke	fscanf,hFile
	add	edi,sizeof sPoint
	cmp	edi,temp
	jna	@0
; ---------------------------------------------------------------------------
        lea	r8d,[rsi].glObject.nPlanes
	mov	edx,offset format_d	; "%d"
	invoke	fscanf,hFile
	xor	edi,edi
	imul	eax,[rsi].glObject.nPlanes,50h
	mov	temp,eax
; ---------------------------------------------------------------------------
@1:	lea	r8d,[rsi+rdi].glObject.planes.p[0*4]
	mov	edx,offset format_d	; "%d"
	invoke	fscanf,hFile
	lea	r8d,[rsi+rdi].glObject.planes.p[1*4]
	mov	edx,offset format_d	; "%d"
	invoke	fscanf,hFile
	lea	r8d,[rsi+rdi].glObject.planes.p[2*4]
	mov	edx,offset format_d	; "%d"
	invoke	fscanf,hFile
	lea	r8d,[rsi+rdi].glObject.planes.normals[0*0Ch].x
	mov	edx,offset format_f	; "%f"
	invoke	fscanf,hFile
	lea	r8d,[rsi+rdi].glObject.planes.normals[0*0Ch].y
	mov	edx,offset format_f	; "%f"
	invoke	fscanf,hFile
	lea	r8d,[rsi+rdi].glObject.planes.normals[0*0Ch].z
	mov	edx,offset format_f	; "%f"
	invoke	fscanf,hFile
	lea	r8d,[rsi+rdi].glObject.planes.normals[1*0Ch].x
	mov	edx,offset format_f	; "%f"
	invoke	fscanf,hFile
	lea	r8d,[rsi+rdi].glObject.planes.normals[1*0Ch].y
	mov	edx,offset format_f	; "%f"
	invoke	fscanf,hFile
	lea	r8d,[rsi+rdi].glObject.planes.normals[1*0Ch].z
	mov	edx,offset format_f	; "%f"
	invoke	fscanf,hFile
	lea	r8d,[rsi+rdi].glObject.planes.normals[2*0Ch].x
	mov	edx,offset format_f	; "%f"
	invoke	fscanf,hFile
	lea	r8d,[rsi+rdi].glObject.planes.normals[2*0Ch].y
	mov	edx,offset format_f	; "%f"
	invoke	fscanf,hFile
	lea	r8d,[rsi+rdi].glObject.planes.normals[2*0Ch].z
	mov	edx,offset format_f	; "%f"
	invoke	fscanf,hFile
	add	edi,50h
	cmp	edi,temp
	jb	@1
; ---------------------------------------------------------------------------
	mov	eax,TRUE
exit0:  leave
	retn
ReadObject endp
SetConnectivity proc  object:qword
local	p1i:dword
local	p2i:dword 
local	p1j:dword
local	p2j:dword
local	vertA1:dword
local	vertA2:dword
local	vertB1:dword
local	vertB2:dword
local	i:dword
local	j:dword
local	edgeA:dword
local	edgeB:dword
local	temp:dword

; ---------------------------------------------------------------------------
	mov	object,rcx
	mov	esi,ecx
	mov	i, 0
; ---------------------------------------------------------------------------
@0:	mov	eax, i
	inc	eax
	mov	j, eax
; ---------------------------------------------------------------------------
@1:	mov	edgeA, 0
; ---------------------------------------------------------------------------
@2:	imul	eax,i,50h
	lea	rax, [rsi+rax+4B8h]
	mov	ecx, edgeA
	cmp	dword ptr [rax+rcx*4+30h],0;if(!o->planes[i].neigh[ki])
	jnz	@5
	mov	edgeB, 0
; ---------------------------------------------------------------------------
@3:	mov	eax,edgeA
	mov	p1i,eax
	inc	eax
	xor	edx, edx
	mov	ecx, 3
	div	ecx
	mov	p2i,edx
	mov	eax,edgeB
	mov	p1j,eax
	inc	eax
	xor	edx, edx
	mov	ecx, 3
	div	ecx
	mov	p2j,edx
	imul	eax,i,50h
	lea	rax, [rsi+rax+4B8h]
	mov	ecx, p1i
	mov	eax, [rax+rcx*4]
	mov	p1i,	eax
	imul	eax,i,50h
	lea	rax, [rsi+rax+4B8h]
	mov	ecx, p2i
	mov	eax, [rax+rcx*4]
	mov	p2i,	eax
	imul	eax,j,50h
	lea	rax, [rsi+rax+4B8h]
	mov	ecx, p1j
	mov	eax, [rax+rcx*4]
	mov	p1j,	eax
	imul	eax,j,50h
	lea	rax, [rsi+rax+4B8h]
	mov	ecx, p2j
	mov	eax, [rax+rcx*4]
	mov	p2j,eax
	mov	eax, p2i
	add	eax, p1i
	mov	temp, eax
	mov	ecx, p1i
	sub	ecx, p2i
	invoke	absy
	mov	ecx, temp
	sub	ecx, eax
	shr	ecx,1
	mov	vertA1,ecx;vertA1=((p1i+p2i)-abs(p1i-p2i))/2
	mov	ecx, p1i
	sub	ecx, p2i
	invoke	absy
	add	eax, temp
	shr	eax,1
	mov	vertA2,eax;vertA2=((p1i+p2i)+abs(p1i-p2i))/2
	mov	eax, p2j
	add	eax, p1j
	mov	temp, eax
	mov	ecx, p1j
	sub	ecx, p2j
	invoke	absy
	mov	ecx, temp
	sub	ecx, eax
	shr	ecx,1
	mov	vertB1,ecx;vertB1=((p1j+p2j)-abs(p1j-p2j))/2
	cmp	vertA1,ecx
	jnz	@4

	mov	ecx, p1j
	sub	ecx, p2j
	invoke	absy
	add	eax, temp
	shr	eax,1
	mov	vertB2,eax;vertB2=((p1j+p2j)+abs(p1j-p2j))/2
	cmp	vertA2,eax
	jnz	@4

	imul	ecx,i,50h
	lea	rcx, [rsi+rcx+4B8h]
	mov	edx, edgeA
	mov	eax, j
	inc	eax
	mov	[rcx+rdx*4+30h],eax;o->planes[i].neigh[edgeA] = j+1

	imul	ecx,j,50h
	lea	rcx,[rsi+rcx+4B8h]
	mov	edx, edgeB
	mov	eax, i
	inc	eax
	mov	[rcx+rdx*4+30h],eax;o->planes[j].neigh[edgeB] = i+1

@4:	inc	edgeB
	cmp	edgeB, 3
	jb	@3
; ---------------------------------------------------------------------------
@5:	inc	edgeA
	cmp	edgeA, 3
	jb	@2
; ---------------------------------------------------------------------------
	inc	j
	mov	eax,[rsi].glObject.nPlanes
	cmp	j, eax
	jb	@1
; ---------------------------------------------------------------------------
	inc	i
        mov	eax,[rsi].glObject.nPlanes
	dec	eax
	cmp	i, eax
	jb	@0
; ---------------------------------------------------------------------------
	leave
	retn
SetConnectivity endp
DrawGLRoom proc
local	dummy[100h]:byte

	invoke	glBegin,GL_QUADS
	xorps	xmm2,xmm2
	movss	xmm1,const1
	xorps	xmm0,xmm0
	invoke	glNormal3f
	movss	xmm2,const_20
	movss	xmm1,const_10
	movss	xmm0,xmm1
	invoke	glVertex3f
	movss	xmm2,const20
	movss	xmm1,const_10
	movss	xmm0,xmm1
	invoke	glVertex3f
	movss	xmm2,const20
	movss	xmm1,const_10
	movss	xmm0,const10
	invoke	glVertex3f
	movss	xmm2,const_20
	movss	xmm1,const_10
	movss	xmm0,const10
	invoke	glVertex3f
	xorps	xmm2,xmm2
	movss	xmm1,const_1
	xorps	xmm0,xmm0
	invoke	glNormal3f
	movss	xmm2,const20
	movss	xmm1,const10
	movss	xmm0,const_10
	invoke	glVertex3f
	movss	xmm2,const_20
	movss	xmm1,const10
	movss	xmm0,const_10
	invoke	glVertex3f
	movss	xmm2,const_20
	movss	xmm1,const10
	movss	xmm0,xmm1
	invoke	glVertex3f
	movss	xmm2,const20
	movss	xmm1,const10
	movss	xmm0,xmm1
	invoke	glVertex3f
	movss	xmm2,const1
	xorps	xmm1,xmm1
	xorps	xmm0,xmm0
	invoke	glNormal3f
	movss	xmm2,const_20
	movss	xmm1,const10
	movss	xmm0,const_10
	invoke	glVertex3f
	movss	xmm2,const_20
	movss	xmm1,const_10
	movss	xmm0,xmm1
	invoke	glVertex3f
	movss	xmm2,const_20
	movss	xmm1,const_10
	movss	xmm0,const10
	invoke	glVertex3f
	movss	xmm2,const_20
	movss	xmm1,const10
	movss	xmm0,xmm1
	invoke	glVertex3f
	movss	xmm2,const_1
	xorps	xmm1,xmm1
	xorps	xmm0,xmm0
	invoke	glNormal3f
	movss	xmm2,const20
	movss	xmm1,const10
	movss	xmm0,xmm1
	invoke	glVertex3f
	movss	xmm2,const20
	movss	xmm1,const_10
	movss	xmm0,const10
	invoke	glVertex3f
	movss	xmm2,const20
	movss	xmm1,const_10
	movss	xmm0,xmm1
	invoke	glVertex3f
	movss	xmm2,const20
	movss	xmm1,const10
	movss	xmm0,const_10
	invoke	glVertex3f
	xorps	xmm2,xmm2
	xorps	xmm1,xmm1
	movss	xmm0,const1
	invoke	glNormal3f
	movss	xmm2,const20
	movss	xmm1,const10
	movss	xmm0,const_10
	invoke	glVertex3f
	movss	xmm2,const20
	movss	xmm1,const_10
	movss	xmm0,xmm1
	invoke	glVertex3f
	movss	xmm2,const_20
	movss	xmm1,const_10
	movss	xmm0,xmm1
	invoke	glVertex3f
	movss	xmm2,const_20
	movss	xmm1,const10
	movss	xmm0,const_10
	invoke	glVertex3f
	xorps	xmm2,xmm2
	xorps	xmm1,xmm1
	movss	xmm0,const_1
	invoke	glNormal3f
	movss	xmm2,const_20
	movss	xmm1,const10
	movss	xmm0,xmm1
	invoke	glVertex3f
	movss	xmm2,const_20
	movss	xmm1,const_10
	movss	xmm0,const10
	invoke	glVertex3f
	movss	xmm2,const20
	movss	xmm1,const_10
	movss	xmm0,const10
	invoke	glVertex3f
	movss	xmm2,const20
	movss	xmm1,const10
	movss	xmm0,xmm1
	invoke	glVertex3f
	invoke	glEnd
	leave
	retn
DrawGLRoom endp
; drawObject    .
DrawGLObject proc object:qword
local	temp:dword
local	j:dword
local	old_edi:dword

	mov	esi,ecx	
	mov	old_edi,edi
	imul	eax,[rsi].glObject.nPlanes,50h
	mov	temp,eax
	
	invoke	glBegin,GL_TRIANGLES
	xor	edi,edi
; ---------------------------------------------------------------------------
@0:	mov	j, 0
; ---------------------------------------------------------------------------
@@:	lea	rax, [rsi+rdi+4B8h]
	imul	ecx,j,0Ch
	movss	xmm2, dword ptr	[rax+rcx+14h]
	movss	xmm1, dword ptr	[rax+rcx+10h]
	movss	xmm0, dword ptr	[rax+rcx+0Ch]
	invoke	glNormal3f
	lea	rax, [rsi+rdi+4B8h]
	mov	ecx, j
	imul	eax,[rax+rcx*4],0Ch
	movss	xmm2, dword ptr	[rsi+rax+10h]
	movss	xmm1, dword ptr	[rsi+rax+0Ch]
	movss	xmm0, dword ptr	[rsi+rax+8]
	invoke	glVertex3f
	inc	j
	cmp	j, 3
	jb	@b
; ---------------------------------------------------------------------------
	add	edi,50h
	cmp	edi,temp
	jb	@0
; ---------------------------------------------------------------------------
	invoke	glEnd
	mov	edi,old_edi
	leave
	retn
DrawGLObject endp

CastShadow proc object:qword, lp:qword
local	side:dword
local	temp:dword
local	old_edi:dword

	mov	old_edi,edi
        mov	lp,rdx
	mov	object,rcx
	mov	esi,ecx	
	imul	eax,[rsi].glObject.nPlanes,50h
	mov	temp,eax
	xor	edi,edi
; ---------------------------------------------------------------------------
@@:	movss	xmm0, dword ptr	[rsi+rdi].glObject.planes.PlaneEq.a
	mulss	xmm0, dword ptr	lp[0*4]
	movss	xmm1, dword ptr	[rsi+rdi].glObject.planes.PlaneEq.b
	mulss	xmm1, dword ptr	lp[1*4]
	addss	xmm0, xmm1
	movss	xmm1, dword ptr	[rsi+rdi].glObject.planes.PlaneEq.c_
	mulss	xmm1, dword ptr	lp[2*4]
	addss	xmm0, xmm1
	movss	xmm1, dword ptr	[rsi+rdi].glObject.planes.PlaneEq.d
	mulss	xmm1, dword ptr	lp[3*4]
	addss	xmm0, xmm1
	movss	side, xmm0
	comiss	xmm0, zero
	setnbe	cl
	mov	byte ptr [rsi+rdi].glObject.planes.visible,cl; 1
	add	edi,50h
	cmp	edi,temp
	jb	@b
; ---------------------------------------------------------------------------
	invoke	glDisable,GL_LIGHTING
	invoke	glDepthMask,GL_FALSE
	invoke	glDepthFunc,GL_LEQUAL
	invoke	glEnable,GL_STENCIL_TEST
	invoke	glColorMask,0,0,0,0
	invoke	glStencilFunc, GL_ALWAYS,1,-1
	invoke	glFrontFace, GL_CCW
	invoke	glStencilOp,GL_KEEP,GL_KEEP,GL_INCR
; ---------------------------------------------------------------------------
	invoke	doShadowPass,object,lp
	invoke	glFrontFace,GL_CW
; ---------------------------------------------------------------------------
	invoke	glStencilOp,GL_KEEP,GL_KEEP,GL_DECR
	invoke	doShadowPass,object,lp
; ---------------------------------------------------------------------------
	invoke	glFrontFace, GL_CCW
	invoke	glColorMask,1,1,1,1
	movss	xmm3,const0_4
	xorps	xmm2,xmm2
	xorps	xmm1,xmm1
	xorps	xmm0,xmm0
	invoke	glColor4f
	invoke	glEnable,GL_BLEND
	invoke	glBlendFunc,GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA
	invoke	glStencilFunc,GL_NOTEQUAL,0,-1
	invoke	glStencilOp,GL_KEEP,GL_KEEP,GL_KEEP
	invoke	glPushMatrix
	invoke	glLoadIdentity
	invoke	glBegin,GL_TRIANGLE_STRIP
	movss	xmm2,const_0_1
	movss	xmm1,const0_1
	movss	xmm0,xmm2
	invoke	glVertex3f
	movss	xmm2,const_0_1
	movss	xmm1,xmm2
	movss	xmm0,xmm2
	invoke	glVertex3f
	movss	xmm2,const_0_1
	movss	xmm1,const0_1
	movss	xmm0,xmm1
	invoke	glVertex3f
	movss	xmm2,const_0_1
	movss	xmm1,xmm2
	movss	xmm0,const0_1
	invoke	glVertex3f
	invoke	glEnd
	invoke	glPopMatrix
	invoke	glDisable,GL_BLEND
	invoke	glDepthFunc,GL_LEQUAL
	invoke	glDepthMask,GL_TRUE
	invoke	glEnable,GL_LIGHTING
	invoke	glDisable,GL_STENCIL_TEST
	invoke	glShadeModel,GL_SMOOTH
	mov	edi,old_edi
	leave
	retn
CastShadow endp
;   
VMatMult proc ;M:qword, v_0:qword

	movss	xmm0, dword ptr	[rcx+0*4]
	mulss	xmm0, dword ptr	[rdx+0*4]
	movss	xmm1, dword ptr	[rcx+4*4]
	mulss	xmm1, dword ptr	[rdx+1*4]
	addss	xmm0, xmm1
	movss	xmm1, dword ptr	[rcx+8*4]
	mulss	xmm1, dword ptr	[rdx+2*4]
	addss	xmm0, xmm1
	movss	xmm1, dword ptr	[rcx+12*4]
	mulss	xmm1, dword ptr	[rdx+3*4]
	addss	xmm0, xmm1

	movss	xmm1, dword ptr	[rcx+1*4]
	mulss	xmm1, dword ptr	[rdx+0*4] ;            |0|   | 0  1  2  3|
	movss	xmm2, dword ptr	[rcx+5*4] ;            |1|   | 4  5  6  7|
	mulss	xmm2, dword ptr	[rdx+1*4] ;            | | * |           |
	addss	xmm1, xmm2                ;            |2|   | 8  9 10 11|
	movss	xmm2, dword ptr	[rcx+9*4] ;            |3|   |12 13 14 15|
	mulss	xmm2, dword ptr	[rdx+2*4]
	addss	xmm1, xmm2
	movss	xmm2, dword ptr	[rcx+13*4]
	mulss	xmm2, dword ptr	[rdx+3*4]
	addss	xmm1, xmm2

	movss	xmm2, dword ptr	[rcx+2*4]
	mulss	xmm2, dword ptr	[rdx+0*4]
	movss	xmm3, dword ptr	[rcx+6*4]
	mulss	xmm3, dword ptr	[rdx+1*4]
	addss	xmm2, xmm3
	movss	xmm3, dword ptr	[rcx+10*4]
	mulss	xmm3, dword ptr	[rdx+2*4]
	addss	xmm2, xmm3
	movss	xmm3, dword ptr	[rcx+14*4]
	mulss	xmm3, dword ptr	[rdx+3*4]
	addss	xmm2, xmm3

	movss	xmm3, dword ptr	[rcx+3*4]
	mulss	xmm3, dword ptr	[rdx+0*4]
	movss	xmm4, dword ptr	[rcx+7*4]
	mulss	xmm4, dword ptr	[rdx+1*4]
	addss	xmm3, xmm4
	movss	xmm4, dword ptr	[rcx+11*4]
	mulss	xmm4, dword ptr	[rdx+2*4]
	addss	xmm3, xmm4
	movss	xmm4, dword ptr	[rcx+4*15]
	mulss	xmm4, dword ptr	[rdx+3*4]
	addss	xmm3, xmm4

	movss	dword ptr [rdx+0*4], xmm0
	movss	dword ptr [rdx+1*4], xmm1
	movss	dword ptr [rdx+2*4], xmm2
	movss	dword ptr [rdx+3*4], xmm3
;leave
	retn
VMatMult endp
CalcPlane proc object:qword,plane:qword
local	v_[4]:sPoint
local	old_edi:dword
        mov	old_edi,edi	
	mov	esi,ecx;esi=object		
	mov	edi,1
; ---------------------------------------------------------------------------
@@:	imul	eax, [rdx+rdi*4-4],0Ch
	imul	ecx,edi,0Ch
	movss	xmm0, dword ptr	[rsi+rax].glObject.points.x
	movss	v_[rcx].x, xmm0
	movss	xmm0, dword ptr	[rsi+rax].glObject.points.y
	movss	v_[rcx].y, xmm0
	movss	xmm0, dword ptr	[rsi+rax].glObject.points.z
	movss	v_[rcx].z, xmm0
	inc	edi
	cmp	edi,3
	jbe	@b
; ---------------------------------------------------------------------------
	movss	xmm0,v_[2*12].z
	subss	xmm0,v_[3*12].z;v[2].z-v[3].z
	mulss	xmm0,v_[1*12].y;v[1].y*(v[2].z-v[3].z)
	movss	xmm1,v_[3*12].z
	subss	xmm1,v_[1*12].z;v[3].z-v[1].z
	mulss	xmm1,v_[2*12].y;v[2].y*(v[3].z-v[1].z)
	addss	xmm0,xmm1
	movss	xmm1, v_[1*12].z
	subss	xmm1, v_[2*12].z;v[1].z-v[2].z
	mulss	xmm1, v_[3*12].y;v[3].y*(v[1].z-v[2].z)
	addss	xmm0, xmm1
	movss	dword ptr [rdx].sPlane.PlaneEq.a,xmm0;[rax+3Ch], xmm0;plane->PlaneEq.a = v[1].y*(v[2].z-v[3].z) + v[2].y*(v[3].z-v[1].z) + v[3].y*(v[1].z-v[2].z)
	movss	xmm0, v_[2*12].x
	subss	xmm0, v_[3*12].x;v[2].x-v[3].x
	mulss	xmm0, v_[1*12].z;v[1].z*(v[2].x-v[3].x)
	movss	xmm1, v_[3*12].x
	subss	xmm1, v_[1*12].x
	mulss	xmm1, v_[2*12].z;v[2].z*(v[3].x-v[1].x)
	addss	xmm0, xmm1
	movss	xmm1, v_[1*12].x
	subss	xmm1, v_[2*12].x;v[1].x-v[2].x
	mulss	xmm1, v_[3*12].z;v[3].z*(v[1].x-v[2].x)
	addss	xmm0, xmm1
	movss	dword ptr [rdx].sPlane.PlaneEq.b,xmm0;plane->PlaneEq.b = v[1].z*(v[2].x-v[3].x) + v[2].z*(v[3].x-v[1].x) + v[3].z*(v[1].x-v[2].x);
	movss	xmm0, v_[2*12].y
	subss	xmm0, v_[3*12].y;v[2].y-v[3].y
	mulss	xmm0, v_[1*12].x;v[1].x*(v[2].y-v[3].y)
	movss	xmm1, v_[3*12].y
	subss	xmm1, v_[1*12].y;v[3].y-v[1].y
	mulss	xmm1, v_[2*12].x;v[2].x*(v[3].y-v[1].y)
	addss	xmm0, xmm1
	movss	xmm1, v_[1*12].y
	subss	xmm1, v_[2*12].y;v[1].y-v[2].y
	mulss	xmm1, v_[3*12].x;v[3].x*(v[1].y-v[2].y)
	addss	xmm0, xmm1
	movss	dword ptr [rdx].sPlane.PlaneEq.c_,xmm0;plane->PlaneEq.c = v[1].x*(v[2].y-v[3].y) + v[2].x*(v[3].y-v[1].y) + v[3].x*(v[1].y-v[2].y);
	movss	xmm0, v_[2*12].y
	mulss	xmm0, v_[3*12].z;v[2].y*v[3].z
	movss	xmm1, v_[3*12].y
	mulss	xmm1, v_[2*12].z;v[3].y*v[2].z
	subss	xmm0, xmm1;v[2].y*v[3].z - v[3].y*v[2].z
	mulss	xmm0,v_[1*12].x;-( v[1].x*(v[2].y*v[3].z - v[3].y*v[2].z)
	movss	xmm1, v_[3*12].y
	mulss	xmm1, v_[1*12].z;v[3].y*v[1].z
	movss	xmm2, v_[1*12].y
	mulss	xmm2, v_[3*12].z;v[1].y*v[3].z
	subss	xmm1, xmm2;v[3].y*v[1].z - v[1].y*v[3].z
	mulss	xmm1, v_[2*12].x;v[2].x*(v[3].y*v[1].z - v[1].y*v[3].z)
	addss	xmm0, xmm1
	movss	xmm1, v_[1*12].y
	mulss	xmm1, v_[2*12].z;v[1].y*v[2].z
	movss	xmm2, v_[2*12].y
	mulss	xmm2, v_[1*12].z;v[2].y*v[1].z
	subss	xmm1, xmm2;v[1].y*v[2].z - v[2].y*v[1].z
	mulss	xmm1,v_[3*12].x;v[3].x*(v[1].y*v[2].z - v[2].y*v[1].z)
	addss	xmm0, xmm1
	mulss	xmm0, const_1
	movss	dword ptr [rdx].sPlane.PlaneEq.d,xmm0;plane->PlaneEq.d =-(v[1].x*(v[2].y*v[3].z - v[3].y*v[2].z) +
; v[2].x*(v[3].y*v[1].z - v[1].y*v[3].z) + v[3].x*(v[1].y*v[2].z - v[2].y*v[1].z) )
        mov	edi,old_edi	
	leave
	retn
CalcPlane endp
absy proc
	mov	eax,ecx
	jns	@f
	neg	eax
@@:	ret
absy endp
doShadowPass proc object:qword, lp:qword
local	i:dword
local	j:dword
local	k:dword
local	jj:dword
local	p1:dword
local	p2:dword
local	v1_:sPoint
local	v2_:sPoint

	and	i, 0
	mov	lp,rdx
@0:	imul	eax,i,50h
	cmp	byte ptr [rsi+rax].glObject.planes.visible,FALSE
	jz	@2
	and	j, 0
; ---------------------------------------------------------------------------
@1:	imul	eax,i,50h
	lea	rax,[rsi+rax].glObject.planes
	mov	ecx,j
	mov	eax,[rax+rcx*4].sPlane.neigh
	mov	k,eax;k = o->planes[i].neigh[j]
	or	eax,eax
	jz	@f
	dec	eax
	imul	eax,50h
	cmp	byte ptr [rsi+rax].glObject.planes.visible,FALSE
	jnz	@4;if (!o->planes[k-1].visible)

@@:	imul	eax,i,50h
	lea	rax,[rsi+rax].glObject.planes
	mov	ecx,j
	mov	eax,[rax+rcx*4]
	mov	p1,eax;p1 = o->planes[i].p[j]
	mov	eax,j
	inc	eax
	xor	edx,edx
	mov	ecx,3
	div	ecx
	mov	jj,edx;jj = (j+1)%3
	imul	eax,i,50h
	lea	rax, [rsi+rax].glObject.planes
	mov	eax, [rax+rdx*4]
	mov	p2, eax;p2 = o->planes[i].p[jj]
	imul	eax,p1,0Ch
	mov	r8, lp
	movss	xmm0, dword ptr	[rsi+rax].glObject.points.x
	subss	xmm0, dword ptr	[r8+0*4]
	mulss	xmm0, infinity
	movss	v1_.x, xmm0
	movss	xmm0, dword ptr	[rsi+rax].glObject.points.y
	subss	xmm0, dword ptr	[r8+1*4]
	mulss	xmm0, infinity
	movss	v1_.y, xmm0
	movss	xmm0, dword ptr	[rsi+rax].glObject.points.z
	subss	xmm0, dword ptr	[r8+2*4]
	mulss	xmm0, infinity
	movss	v1_.z, xmm0
	imul	eax,p2,0Ch
	movss	xmm0, dword ptr	[rsi+rax].glObject.points.x
	subss	xmm0, dword ptr	[r8+0*4]
	mulss	xmm0, infinity
	movss	v2_.x, xmm0
	movss	xmm0, dword ptr	[rsi+rax].glObject.points.y
	subss	xmm0, dword ptr	[r8+1*4]
	mulss	xmm0, infinity
	movss	v2_.y, xmm0
	movss	xmm0, dword ptr	[rsi+rax].glObject.points.z
	subss	xmm0, dword ptr	[r8+2*4]
	mulss	xmm0, infinity
	movss	v2_.z, xmm0
	invoke	glBegin,GL_TRIANGLE_STRIP
	imul	eax,p1,sizeof sPoint
	movss	xmm2, dword ptr	[rsi+rax].glObject.points.z
	movss	xmm1, dword ptr	[rsi+rax].glObject.points.y
	movss	xmm0, dword ptr	[rsi+rax].glObject.points.x
	invoke	glVertex3f
	imul	eax,p1,sizeof sPoint
	movss	xmm2, dword ptr	[rsi+rax].glObject.points.z
	addss	xmm2, v1_.z
	movss	xmm1, dword ptr	[rsi+rax].glObject.points.y
	addss	xmm1, v1_.y
	movss	xmm0, dword ptr	[rsi+rax].glObject.points.x
	addss	xmm0, v1_.x
	invoke	glVertex3f
	imul	eax,p2,sizeof sPoint
	movss	xmm2, dword ptr	[rsi+rax].glObject.points.z
	movss	xmm1, dword ptr	[rsi+rax].glObject.points.y
	movss	xmm0, dword ptr	[rsi+rax].glObject.points.x
	invoke	glVertex3f
	imul	eax,p2,sizeof sPoint
	movss	xmm2, dword ptr	[rsi+rax].glObject.points.z
	addss	xmm2, v2_.z
	movss	xmm1, dword ptr	[rsi+rax].glObject.points.y
	addss	xmm1, v2_.y
	movss	xmm0, dword ptr	[rsi+rax].glObject.points.x
	addss	xmm0, v2_.x
	invoke	glVertex3f
	invoke	glEnd
@4:	inc	j
	cmp	j, 3
	jb	@1
; ---------------------------------------------------------------------------
@2:	inc	i
	mov	eax,[rsi].glObject.nPlanes
	cmp	i, eax
	jb	@0
	leave
	retn
doShadowPass endp
;---------------------------------------------------------------------------
hDC	dq	?
hRC	dq	?
PixFrm	label	PIXELFORMATDESCRIPTOR 
	nSize             dw	sizeof PIXELFORMATDESCRIPTOR
  	nVersion          dw	1
  	dwFlags           dd	PFD_SUPPORT_OPENGL or PFD_DOUBLEBUFFER or PFD_DRAW_TO_WINDOW
  	iPixelType        db	PFD_TYPE_RGBA
  	cColorBits        db	32;Select Our Color Depth
  	cRedBits          db	0
  	cRedShift         db	0
  	cGreenBits        db	0
  	cGreenShift       db	0
  	cBlueBits         db	0
  	cBlueShift        db	0;Color Bits Ignored
  	cAlphaBits        db	0;No Alpha Buffer
  	cAlphaShift       db	0;Shift Bit Ignored
  	cAccumBits        db	0;No Accumulation Buffer
  	cAccumRedBits     db	0
  	cAccumGreenBits   db	0
  	cAccumBlueBits    db	0
  	cAccumAlphaBits   db	0;Accumulation Bits Ignored
  	cDepthBits        db	16;16Bit Z-Buffer (Depth Buffer)
  	cStencilBits      db	1;No Stencil Buffer
  	cAuxBuffers       db	0;No Auxiliary Buffer
  	iLayerType        db	PFD_MAIN_PLANE;Main Drawing Layer
  	bReserved         db	0;Reserved
  	dwLayerMask       dd	0
  	dwVisibleMask     dd	0
  	dwDamageMask      dd	0;Layer Masks Ignored

szClassName	db "NeHe lesson#27: Shadow Casting Tutorial",0
FileName	db "br_Rabbit3.cur",0
aObject		db "Object2.txt",0
format_d	db "%d",0
format_f	db "%f",0
readmode	db "r",0
obj		glObject <>
LightPos	dd    0, 5.0,-4.0, 1.0; Light position
LightAmb	dd  0.2, 0.2, 0.2, 1.0; Ambient light values
LightDif	dd  0.6, 0.6, 0.6, 1.0; Diffuse light values
LightSpc	dd -0.2,-0.2,-0.2, 1.0; Specular light values
MatAmb		dd  0.4, 0.4, 0.4, 1.0; Material - ambient values
MatDif		dd  0.2, 0.6, 0.9, 1.0; Material - diffuse values
MatSpc		dd    0,   0,   0, 1.0; Material - specular values
MatShn		dd 0; Material - shininess
ObjPos		dd -2.0,-2.0,-5.0; Object position
q		dq ?; Quadratic for drawing a sphere
SpherePos	dd -4.0,-5.0,-6.0;
;-----------------------------
;float
zero		dd 0
const0_001 	dd 0.001
const0_01 	dd 0.01
const0_05 	dd 0.05
const0_1 	dd 0.1
const_0_1	dd -0.1
const0_4	dd 0.4
const0_5	dd 0.5
const0_7	dd 0.7
const1		dd 1.0
const_1		dd -1.0
const7		dd 7.0
const10		dd 10.0
const_10	dd -10.0
const20		dd 20.0
const_20	dd -20.0
infinity	dd 100.0
;double
constd0_001	dq 0.001
constd0_2	dq 0.2
constd1		dq 1.0
constd1_5	dq 1.5
constd45	dq 45.0
constd100	dq 100.0
align 16
rot	dd 0,0,0,0;X and Y Rotation
speed	dd 0,0,0,0;X and Y Rotation Speed
end